
August 1988 Cadence article (c) 1988 Pan-Dimensional Research

written June 21,1988 by Michael Liska



title:    C'ing IS BELIEVING... A REAL WORLD EXAMPLE



At first I thought writing articles for Cadence magazine would be

simple.  If I were to present some of my work over the last six

years, I thought, I could encourage more people to start viewing

AutoCAD in a different light.  Like you, I receive Cadence by

subscription and when I had a chance to read my own June article

I knew I was in trouble.  As some of you may know by now, the

wrong source code for the dxf translator was publish (It is

available for down load on our BBS system) but the worst part is

that what comes naturally to me, is very difficult to explain in

print.  Several people I talked to after the June article pointed

out to me that they were not interested in dxf translation.  Why

bother writing a program to translate when AutoCAD does it anyway

and why translate to dxf if we just have to write more code to

process a dxf file.  As it turns out what is needed out there in

AutoCAD land, is a way to process the attribute information in a

bunch of drawings, and to show how it is done without a lot of

theoretical junk thrown in to confuse the issue ie:  THE REAL WORLD.

    Before my exposure to AutoCAD, I owned a small company called CableCAD

that had a contract to design and draft the apartment complexes in Pasedena

California for cable television.  I wrote a coordinate geometry package for

a Radio Shack 16B computer running Xenix.  The graphics were crude compared

to today's standard, but it worked and I was able to do a lot of production.

When I first saw AutoCAD I knew I had to have it, version 1.5 was a tremendous

leap into real production.  1.5 allowed me to pick up other contracts and my

CATV days shifted into high gear.  With AutoCAD, drafting was under control

but designing the CATV system was still done by hand.

     Owning a UNIX/XENIX system in the early 80's represented a tremendous

dollar expense, when I switch to PC's running AutoCAD I couldn't bear the thought

of that machine just sitting there not earning it's keep.  My first attempt at

doing CATV RF design was a Multiplan spreadsheet, don't laugh it worked!  By

inputting the footages between telephone poles and the appropraite design

parameters the spreadsheet would spit out the correct RF design.  Nothing fancy

mind you, but it did save a considerable amount of time.

     Once in a while fate steps in and gives you a helping hand.  2.0 followed

quickly by 2.18 AutoCAD taught me the real power of attributes.  I was able

to store in each telephone pole not only the hardware values for the CATV system

but the footages between poles and how they were interconnected.  By connecting

the PC's to the Radio Shack, I could upload all the attribute values in a

drawing, stuff them into my spreadsheet and design to my hearts content.

     As time went on the spreadsheet RF design program was abandoned and I

switched to the Unify database management system.  Unify is to minicomputers and

mainframes what dBase is to a micro.  The power of Unify is incredible with

a wide open interface to 'C' programs.  RF design went from spreadsheet style

to fully interactive.  Attribute values were put to use for bill's of material.

With the frosting on the cake being the tracking of my invoiceing (I got paid

by the foot for completed work).

      Enter now the .dwg file.  AutoLISP as we know it today was still a gleam

in the eyes of our friends at AutoDESK.  If I could extract attribute information

from an AutoCAD file why not stuff the calculated values (via Unify) back in.

Saving myself the laborious task of reading a printout from the design program

and updating the drawing by hand.

     The rest of this article is dedicated to my old friend Bill

Greer of Cable Graphics.  Bill and I have been friends since the

days when a hot AutoCAD system was a dual floppy IBM/PC running

AutoCAD 1.5 (believe it or not that system cost us over nine

thousand dollars not including AutoCAD). Together we designed

cable television systems in southern California.  Cities to our

credit include Muscoy, San Dimas, Laverne, Walnut, West Covina and

a host of others.  A couple of years back we went our separate

ways, I was tired of drawing and wanted to get into something else

however Bill is carrying on in the CATV field.  He

currently is drawing and designing the city of Philadelphia all

by himself using three high speed AutoCAD systems!  Bill currently

produces some forty miles of complete CATV design and base maps

per week, the equivalent production of six hand drafter's.

Production such as this is very common in the AutoCAD world.  All

it takes is some careful planning, well thought out drafting

standards so that custom menus and AutoLISP macros can be created

to speed up the drawing process, and a few clever DOS batch run

programs to do the mundane but necessary chores.  Now Bill doesn't

draw on three computers at once but all three are kept busy,

here's how.  Computer 1 is used exclusively as a plotter driver, a

typical 24 by 36 inch city map drawn to a scale of 1 inch equals 200 feet can

take upwards of 2 hours to plot ink on mylar.  Over the years, we found out

that it was cheaper and faster to dedicate a computer for plotting than to use

spoolers of either the hardware or software type.  Computer 2 is

Bill's AutoCAD drawing station.  A very capable

machine with high resolution graphics (1024x768) "Verticom H-16 if you must

know " and lot's of memory.  The graphics card was chosen not only for it's

speed but for the pleasing display it produces.  If you ever sat at your

machine for more that 12 hours working on a very detailed drawing

you will know that speed is secondary to reducing eye fatigue.

Computer 3 is the hired help, it works 24 hours a day seven days a

week without complaint or the need for a paycheck.  And it is with

computer 3 that our story unfolds.

     Figure 1 shows a small corner of a typical CATV construction

map.  As you can see telephone poles are represented by special

symbols.  Some telephone poles are empty circles some have an X in

them and others are just an X.  Each telephone pole has a special

meaning.   The empty circles represent poles that have only

telephone on them, circles with an X have both electricity and

telephone on them, X poles have only electricity, and filled

circles are CATV only poles.  The reason it is important for the

CATV company to distinguish poles is that they have to pay rent to

the owner of the pole.  Telephone poles are not public domain,

they belong to someone, be it the power or telephone company or in

some cases the poles the CATV company installs.  In the title

block of a typical CATV system is the total number of each type of pole

for the given map.  Now you might think that a simple AutoLISP

routine could count the different types of poles and fill in the

title block.  Well the answer is yes, and algorithms of that nature

have been presented in this magazine before, however, a typical CATV map

of a densely populated area may contain some 300 poles with each

pole containing 6 or more attributes used for other purposes, and

a typical city may contain 200 or more maps all of which are in

constant revision until the final electronic design is approved!

Besides if we can do something simple like "count and amounts" then

anything you can imagine should be easy to implement in 'C' that

would otherwise be impossible in AutoLISP.

     We have now completed our first step which is to outline the problem.

That is, to count the number of each type of pole (inserted block)

in a AutoCAD .dwg file and fill in the title block (another

inserted block with attribute values representing each type of

pole).  I can see light bulbs going on all over AutoCADom.  The

title block we are about to fill in could just as easily be the

cover sheet for a multipage architectural drawing and we could

count the number of doors or windows to fill in a bill of

materials.  In the pc board field we could be counting how many 16

pin dual inline ic sockets we need to order.  Practically any

application where we need to know how many items there are in an

unlimited number of constantly revised drawings, can use, with simple

modification, the following code.

     To keep the program easy to understand and get working we

need to follow some rules.  Rule number one is the .dwg file will

have been regened before we process it.  Clarifying that further

no block will have been ROTATED, SCALED, STRETCHED or otherwise edited

and then left in a now regened state.  Many commercial packages are not

working correctly because of the regen rule.  AutoCAD has a very clever

way of tacking pseudo entities at the end of a .dwg file and the 'C'

code to track down the now non-regened entities requires the use of

multiple offsets that would take an entire article just to

explain. However, Release 10's .dwg file is a lot easier to

process and I will bring you up to speed on that later.  Rule

number 2 is, we will allow plenty of room in the attribute we

are to fill in for the text string.  AutoCAD stores attribute

values as text strings.  The .dwg attribute entity itself contains

a number which represents the length of the attribute text string.

If we wish to store the number "123" in our count of telephone

poles we need room for the three characters.  If we have less than

three characters we will pad the string with enough spaces to

create a string with the proper length.  The text that will appear

on the drawing will always be left justified, padded with spaces on

the right if needed, if we try to output a string with more

characters than AutoCAD has room for we will output blank spaces

so that the attribute area appears blank.  Rule number 3 is, the

block name and the attribute tag will be the same.  We can cut

down on the amount of code we need to write using the same names.

Rule 4, the blocks that we are concerned with are not nested.

     To create our empty attribute we use the ATTDEF command and

create an attribute tag corresponding to the block name of the

pole and a default attribute value of "XXX" because we will never

have more than 999 poles on any particular map. If your

application requires more room than 3 characters then by all means

increase the length the of the default attribute value.

     Figure 2 shows the attribute portion of the CATV title block.

We are using 4 attributes.  Attribute 1 has a tag called TELCO for

telephone poles, attribute 2's tag is ELECTRIC for the electric

utility poles, attribute 3's tag is JOINT for joint use poles

(both electric and telephone) and attribute 4 is CATV for system

installed poles.  Also shown are the 4 blocks with there

respective names.

     Our AutoCAD setup portion of the job is done.  We now do our

AutoCAD drawing insert the poles where needed and when finished

we insert the title block with the default attribute values ZOOM

ALL the drawing (remember the regen rule) and were finished.  Now

for the fun part.

   Here is what the program has to do.

      open an AutoCAD .dwg file

      read in the block name table

      go to the start of the entity section

      look for our blocks and ignore everything else

      if it is one of our blocks increment the appropriate counter

      if we find the title block keep track of where it is

      when we are done counting update the title block

      close the .dwg file

      tell DOS we are done and everything's okay


	From here what's needed is a batch file to control the program.

I use batch driven programs because of the ease in which you can process

entire directories of drawings and the fact that most programs of this nature

use command line arguments for block names etc.  All you need to do is

modify the batch file instead of the program itself.  Where batch files really

shine however, is in there error trapping abilities.  Notice in the 'C' listing,

we terminate execution of the program by the exit() function returning a value

to DOS.  If the value is 0 all is well, where as a 1 means trouble.  By using the

return values to control the batch file we can avoid the unfortunate situation

of starting up a program, only to find out the next day that it only processed

3 drawings out of 170 and gave up because of a silly mistake.  The batch listing

shows a simple batch file to process all the drawing in the current directory

If you feel up to it you can modify the file to include your own error handling

routines.  A very useful addition would be to place the names of the .dwg files

that could not be processed, in a disk file or sent to the printer.

COUNTEM.BAT

FOR %%X IN (*.DWG) DO COUNTHEM %X


     Now that we know what attributes are all about and how easy it is to

process the .dwg file, your favorite application is just waiting to be written.

Tune in next time for the marriage of the century, dBase III and AutoCAD.



Michael Liska





/* COUNTHEM.C   (c) 1988 Pan-Dimensional Research
                    PO BOX 1439
                    Guerneville, CA  95446
		    707-869-0682
                    Michael Liska
                    modified for publication June 21, 1988

For education purposes only,  presented here for the non profit
use of AutoCAD end user's only.  Pan-Dimensional Research makes
no warranty and provides no support for the following program  */


 /* WARNING... This program reads and WRITES to an AutoCAD binary
    drawing file.  Minimal error checking is presented here so that
    the underlying algorithm can be shown.  YOU CAN corrupt a drawing
    if you are not careful.  */



#include <stdio.h>           /* use standard i/o package */
#include <string.h>          /* string handling functions */
#include <math.h>            /* even though we are not doing any calculations */
#include <stdlib.h>          /* the compiler likes this library loaded for    */
                             /* storing double precision floating point numbers */
			     /* which a .dwg file contains a bunch of   */

FILE *dwgptr;                /* file handle for .dwg file */

#define DELETED 0x80         /* deletion flag */
#define BYFLAG  0x03         /* does it have BYLAYER info */
#define ZFLAGS  0x0c         /* check for elevation and thickness */
#define ATTFLAG 0x80         /* attribute's follow flag very handy */
#define ATTRIB  0x10         /* the attribute entity  */
#define INSERT  0x0e         /* the insert entity  */
#define SEQEND  0x11         /* the sequend entity */
#define MAX     5            /* how many blocks to search for */
#define LEN     32           /* maximum length of a block name */

/* structures to handle the important things in life */
/* this one is for the entities themselves the first eight bytes remember */

struct header {
               unsigned char name;
               char bits;
               char size;
               char notneeded;
               int  layer;
               char txtflags;
               char soonnow;
              };

typedef struct header FLAGS;

/* this one stores the offsets to where things are    */

struct file_header {
                     char version[20];
                     long entstart;
                     long blocktable;   /* not the definitions just the names */
                     char skip[16];     /* don't need for this application */
                     int  blocksize;    /* in case you use UNIX with long names */
                     int  numblocks;    /* really a long but with DOS we don't care  */
                                        /* used to allocate space for block names */
                   };

typedef struct file_header OFFSETS;

static char blocks[MAX][LEN] =
                               { "JOINT",       /* the five blocks we will search for */
                                 "TELCO",       /* this is where your block names go */
                                 "ELECTRIC",    /* an exercise for you would be to have the */
                                 "CATV",        /* block names fed to the program via command */
                                 "TITLE" };     /* line arguments...   that's the way I do it */

/* this program makes no function calls other than the standard libraries */
/* too many people got confused last time  main() is declared type void */
/* because we will only leave the program via the exit() function to return */
/* a value to DOS so that a DOS batch file can control the program  */


void main(argc,argv)    /* the entry point into the program */
int argc;               /* how many command line arguments  */
char *argv[];           /* a place to put them */

 {
               /* program variables structures first  */

      struct {
               char bytypes[2];   /* we are only counting the number of inserted */
             } bynums;            /* blocks we are interested in.  however we need */
                                  /* a place to store BYLAYER and BYCOLOR information */
                                  /* just in case */

      struct {                    /* the same holds true here  just in case a block was */
               double elevation;  /* inserted with an elevation or thickness..  a brief */
               double thick;      /* departure here is in order  this program was modified */
             } zfloats;           /* from our daily use program which not only counted and */
                                  /* filled in the title blocks but also loaded our database */
                                  /* with attribute information for an RF design program     */
      struct {                    /* the program was originally written in 1985 when I still */
		double x;         /* thought cable tv was a great idea  ..sorry Joe (woof woof).. */
                double y;
		double h;
	     } attfloats;

      OFFSETS offset;
      FLAGS  headers;

      int x,bcount,skips,telco,electric,joint,catv;  /* the names of your variables go here */
      int txtlen;                                    /* if you want to get fancy, they should */
                                                     /* come from the command line arguments */

     char *blckname[256],name[33],blcknum;           /* I know AutoCAD allows more than 256 loaded */
     char *attag,*attext;                            /* blocks  If you are using more that 256 then */
                                                     /* you must either receive regen compansation or */
						     /* have never read about shapes */

      long titleoffset,where;

      titleoffset = 0L;
      catv = telco = electric = joint = bcount = 0;  /* our counters are set to 0 */

        /* check command line arguments */

             if(argc != 2){                         /* we will run this program from a DOS batch file */
                 printf("\nUsage : countem file");  /* if a return value of 1 is trapped we will */
                 exit(1);}                          /* take appropriate action at the DOS level  */

             if((dwgptr = fopen(argv[1],"r+b")) == NULL){
                 printf("\nDWG file open error");        /* open the dwg file */
                 exit(1);}

             fread(&offset,sizeof(offset),1,dwgptr);      /* read in our offset information */


                                                        /* this gets a little sticky so bear with me */
             for(x = 0; x < offset.numblocks; x++){     /* we set up a loop to process each block name */

              fseek(dwgptr,offset.blocktable + (x * offset.blocksize) + 1,0);
                                                        /* we went to the block name text  */
              fread(&name,sizeof(name),1,dwgptr);       /* read the name into a temporary buffer */
							/* that takes care of the null terminator for us */
	      blckname[x] = strdup(name);       	/* then stuff it into the array creating space on the fly */
               if(! strnicmp(blckname[x], "\*",1)){     /* if the block has an * in front of it then it was */
                  itoa(bcount,name,10);                 /* created by AutoCAD and is either a hatch pattern or */
                  strcat(blckname[x],name);             /* dimension picture so we must give it a number and add it */
                  bcount++;}}                           /* to the name to come up with it's true identity and add 1 to */
                                                        /* bcount in case there are more  */

/* let's take a break at this point and look at what was accomplished so far
  the .dwg file is now open we've read in the portion of the offset table
  that we needed and we've taken care of the nasty job of reading in all
  of the block names.  In the definition of an INSERT entity there
  is a number that corresponds to the block name.  If TELCO was the first
  inserted block then the entity would contain the number 0 referring
  to the first index of the blckname array, 0 is a valid number in C. If the
  next block was JOINT then it's index would be 1 and so on.  Although we
  only need be concerned about a blocks number, by reading in all of the blocks
  allows us to perform some very sophisticated error checking.  For example
  a good routine to include would be to see if the title block was present
  if there is no title block then there is no need to count, ie: no place to put
  the totals.  Checking to see if one of your drafters decided to redefine a
  block is always a good idea otherwise your totals may come up short.  Reading
  in the entire block table guards against counting the wrong items.  Even
  though you may use a default drawing with your blocks loaded it does not
  guarantee that the order of block table is always the same. */

          /* scanning the entity section */

             fseek(dwgptr,offset.entstart,0);             /* go to the first entity */
	     where = ftell(dwgptr);
             while(where != offset.blocktable){           /* loop through all entities */
              fread(&headers,sizeof(headers),1,dwgptr);   /* read an entity */
               skips = 0;
               if((headers.name & DELETED) != DELETED &&
                             headers.name == INSERT){      /* is it a none deleted block */
                       switch(headers.bits & BYFLAG){      /* skip past any possible bycolors or */
                           case 1:                         /* floating linestyles or elevations  */
                           case 2:                         /* and thicknesses that might be present */
                                fread(&bynums,sizeof(char),1,dwgptr);
                                skips = skips + sizeof(char);
                                break;
                           case 3:
                                fread(&bynums,2 * sizeof(char),1,dwgptr);
                                skips = skips + (2 * sizeof(char));
                                break;
                          default:
                                break;}
                        switch(headers.bits & ZFLAGS){
                          case 4:
                          case 8:
                                fread(&zfloats,sizeof(double),1,dwgptr);
                                skips = skips + sizeof(double);
                                break;
                         case 12:
                                fread(&zfloats,sizeof(zfloats),1,dwgptr);
                                skips = skips + sizeof(zfloats);
                                break;
                         default:
                                break;}
                fread(&blcknum,sizeof(blcknum),1,dwgptr);
                skips = skips + sizeof(blcknum);

          /* now we search through the block names looking for our block */

                       for(x = 0; x < MAX; x++){
                        if(strcmp(blocks[x],blckname[(int)blcknum]) == 0)
                            switch(x){
                                   case 0:
                                        joint++;
                                        break;
                                   case 1:
                                        telco++;
                                        break;
                                   case 2:
                                        electric++;
                                        break;
                                   case 3:
                                        catv++;
                                        break;
                                   case 4:
                                        titleoffset = ftell(dwgptr) - sizeof(headers) - skips;
                                        break;
                                   default:
                                        printf("\nAn error occured");
                                        exit(1);
                                        break;}

                                            }}
          fseek(dwgptr,headers.size - sizeof(headers) - skips,1);
	  where = ftell(dwgptr);}                                  /* go to the next entitiy */

      /* our counter variables now contain how many of each block is in the drawing */
      /* and we also know the direct offset to the title block.  You might want to  */
      /* consider another error checking routine just in case two title blocks were */
      /* inserted one on top of the other, it does happen. */

          if(titleoffset == 0L){                                  /* make sure titleblock was found */
	     printf("\nTitle block not loaded");exit(1);}

             fseek(dwgptr,titleoffset,0);                         /* go directly to the title block */
             fread(&headers,sizeof(headers),1,dwgptr);            /* read the insert portion in     */

          if((headers.bits &  ATTFLAG) != ATTFLAG){               /* check to make sure attributes follow flag */
	     printf("\nAttribute follow flag missing");exit(1);}  /* is set, just in case someone redifined the */
                                                                  /* title block */
             fseek(dwgptr,headers.size - sizeof(headers),1);      /* go to the first attribute entity */

      /* we are about to fill in the title block  first we must convert our counters */
      /* which are integers into printable strings  then we will insure that our string */
      /* is the same length or shorter than what is allready stored in the title block */
      /* we checked the title block entity to make sure it does have attribute values */
      /* assigned to it just in case the title block was redifined, the process of stepping */
      /* through a block with attributes is very similar to an AutoLISP routine run inside */
      /* the drawing editor.  We step through each attribute until we encounter the SEQEND */


           printf("\nCATV %d JOINT %d ELECTRIC %d TELCO %d",catv,joint,electric,telco);
           do{                                                  /* set up loop */
              fread(&headers,sizeof(headers),1,dwgptr);         /* read the first attribute */
              fread(&attfloats,sizeof(attfloats),1,dwgptr);     /* read the xy insertion and the text height */
	        skips = sizeof(attfloats);
                switch(headers.bits & BYFLAG){
			case 1:
			case 2:
			      fread(&bynums,sizeof(char),1,dwgptr);
			      skips = skips + sizeof(char);             /* this sequence of code is the same as above */
			      break;                                    /* and really should be done in a function call */
			case 3:                                         /* I will leave that as a exercise for you to */
			      fread(&bynums,2 * sizeof(char),1,dwgptr); /* create a C function to deal with Bylayer and */
			      skips = skips + (2 * sizeof(char));       /* elevation,thickness information */
			      break;
			default:
			      break;}
		switch(headers.bits & ZFLAGS){
			case 4:
			case 8:
			      fread(&zfloats,sizeof(double),1,dwgptr);
			      skips = skips + sizeof(double);
			      break;
			case 12:
			      fread(&zfloats,sizeof(zfloats),1,dwgptr);
			      skips = skips + sizeof(zfloats);
			      break;
			default:
			      break;}

                   fread(&txtlen,sizeof(txtlen),1,dwgptr);     /* length of the attribute text */
		   attext = (char *) calloc(1, (txtlen + 1));  /* create a space to store the text */
                   where = ftell(dwgptr);                      /* keep track of where the text needs to be */
		   skips = skips + sizeof(txtlen) + txtlen;    /* calculate the skip value to the next entity */
                   fread(attext,txtlen,1,dwgptr);              /* read in the attribute text you might  */
		                                               /* you might want to check to make sure it */
			           			       /* is XXX */
                   fread(&txtlen,sizeof(txtlen),1,dwgptr);
		   attag = (char *) calloc(1, (txtlen + 1));   /* do the same for the attribute tag */
		   fread(attag,txtlen,1,dwgptr);               /* which is really what we want  */

                   for(x = 0; x < MAX; x++)
		    if(strcmp(&blocks[x],attag) == 0){
		      switch(x){
			      case 0:
                                    itoa(joint,attext,10);
				    break;
			      case 1:
				    itoa(telco,attext,10);
				    break;
			      case 2:
				    itoa(electric,attext,10);
				    break;
			      case 3:
				    itoa(catv,attext,10);
				    break;
			     default:
				    printf("\nAn error occured");
				    exit(1);
				    break;}

                           while(strlen(attext) < 3){
				strcat(attext," ");}

		       fseek(dwgptr,where,0);                                /* go back to where the text needs to be written */
                       fwrite(attext,sizeof(char),strlen(attext),dwgptr);}   /* write the new attribute value,  check your c  */
                                                                             /* compiler documentation to make sure the null  */
		   fseek(dwgptr,headers.size - sizeof(headers) - skips,1);   /* charactor is not written to the file          */
                   }while(headers.name != SEQEND);                           /* read the next entity */

           fclose(dwgptr);                     /* close the drawing file */
	   printf("\nProcessing complete\n\n ");
           exit(0);                            /* exiting program returning zero, everything is okay */

 }   /* close function main */